<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Socket&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Socket.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Socket-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Socket&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::Socket&lt; T &gt;:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1Socket.png" usemap="#OpenSim::Socket_3C_20T_20_3E_map" alt=""/>
  <map id="OpenSim::Socket_3C_20T_20_3E_map" name="OpenSim::Socket_3C_20T_20_3E_map">
<area href="classOpenSim_1_1AbstractSocket.html" title="A Socket formalizes the dependency between a Component and another object (typically another Componen..." alt="OpenSim::AbstractSocket" shape="rect" coords="0,0,154,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a55336bf0a8b5e3b360eb49e58c0926c2"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a55336bf0a8b5e3b360eb49e58c0926c2">~Socket</a> ()</td></tr>
<tr class="separator:a55336bf0a8b5e3b360eb49e58c0926c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7a4df9d9828850fe0d3cae7d7bb46dc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1Socket.html">Socket</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#aa7a4df9d9828850fe0d3cae7d7bb46dc">clone</a> () const override</td></tr>
<tr class="memdesc:aa7a4df9d9828850fe0d3cae7d7bb46dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a dynamically-allocated copy.  <a href="classOpenSim_1_1Socket.html#aa7a4df9d9828850fe0d3cae7d7bb46dc">More...</a><br /></td></tr>
<tr class="separator:aa7a4df9d9828850fe0d3cae7d7bb46dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85d80ce024bb2ba53cc52019f91ca7bc"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a85d80ce024bb2ba53cc52019f91ca7bc">isConnected</a> () const override</td></tr>
<tr class="memdesc:a85d80ce024bb2ba53cc52019f91ca7bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is the <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> connected to object of type T?  <a href="classOpenSim_1_1Socket.html#a85d80ce024bb2ba53cc52019f91ca7bc">More...</a><br /></td></tr>
<tr class="separator:a85d80ce024bb2ba53cc52019f91ca7bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25c9aaf45468ad895c5b1bc8bc7c9246"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a25c9aaf45468ad895c5b1bc8bc7c9246">getConnecteeAsObject</a> () const override</td></tr>
<tr class="memdesc:a25c9aaf45468ad895c5b1bc8bc7c9246"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic access to the connectee.  <a href="classOpenSim_1_1Socket.html#a25c9aaf45468ad895c5b1bc8bc7c9246">More...</a><br /></td></tr>
<tr class="separator:a25c9aaf45468ad895c5b1bc8bc7c9246"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5eba84c6d4b19217bfe2db20f895b47"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#aa5eba84c6d4b19217bfe2db20f895b47">getConnectee</a> () const</td></tr>
<tr class="memdesc:aa5eba84c6d4b19217bfe2db20f895b47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Temporary access to the connectee for testing purposes.  <a href="classOpenSim_1_1Socket.html#aa5eba84c6d4b19217bfe2db20f895b47">More...</a><br /></td></tr>
<tr class="separator:aa5eba84c6d4b19217bfe2db20f895b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c3191db7766adfb42f7312c0d364ef4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a5c3191db7766adfb42f7312c0d364ef4">connect</a> (const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;object) override</td></tr>
<tr class="memdesc:a5c3191db7766adfb42f7312c0d364ef4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> to the provided connectee object.  <a href="classOpenSim_1_1Socket.html#a5c3191db7766adfb42f7312c0d364ef4">More...</a><br /></td></tr>
<tr class="separator:a5c3191db7766adfb42f7312c0d364ef4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:accb8a43c9bc42c12d37d80836ece8de4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#accb8a43c9bc42c12d37d80836ece8de4">findAndConnect</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;connectee) override</td></tr>
<tr class="memdesc:accb8a43c9bc42c12d37d80836ece8de4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find a component using a partial path or component name of the correct type anywhere in the model (using Component::findComponent()) and connect to that component.  <a href="classOpenSim_1_1Socket.html#accb8a43c9bc42c12d37d80836ece8de4">More...</a><br /></td></tr>
<tr class="separator:accb8a43c9bc42c12d37d80836ece8de4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78d4f73ee2cbba0e3052463d71017367"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">finalizeConnection</a> (const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;root) override</td></tr>
<tr class="memdesc:a78d4f73ee2cbba0e3052463d71017367"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> given its connectee path property <br  />
  <a href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">More...</a><br /></td></tr>
<tr class="separator:a78d4f73ee2cbba0e3052463d71017367"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9029eb41cd05fbbddae7259b464e008b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a9029eb41cd05fbbddae7259b464e008b">disconnect</a> () override</td></tr>
<tr class="memdesc:a9029eb41cd05fbbddae7259b464e008b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear references to connectees.  <a href="classOpenSim_1_1Socket.html#a9029eb41cd05fbbddae7259b464e008b">More...</a><br /></td></tr>
<tr class="separator:a9029eb41cd05fbbddae7259b464e008b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4da865809554a425bbaa98f4a30a2dc0"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a4da865809554a425bbaa98f4a30a2dc0">getConnecteeTypeName</a> () const override</td></tr>
<tr class="memdesc:a4da865809554a425bbaa98f4a30a2dc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Derived classes must satisfy this Interface.  <a href="classOpenSim_1_1Socket.html#a4da865809554a425bbaa98f4a30a2dc0">More...</a><br /></td></tr>
<tr class="separator:a4da865809554a425bbaa98f4a30a2dc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78e253243a1eab086aba8591ec1f9bb6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#a78e253243a1eab086aba8591ec1f9bb6">SimTK_DOWNCAST</a> (<a class="el" href="classOpenSim_1_1Socket.html">Socket</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html">AbstractSocket</a>)</td></tr>
<tr class="separator:a78e253243a1eab086aba8591ec1f9bb6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1AbstractSocket"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1AbstractSocket')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1AbstractSocket.html">OpenSim::AbstractSocket</a></td></tr>
<tr class="memitem:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a868b675e08eb429427ec1d0d95338ed8">~AbstractSocket</a> ()</td></tr>
<tr class="separator:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">getName</a> () const</td></tr>
<tr class="separator:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">SimTK::Stage&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">getConnectAtStage</a> () const</td></tr>
<tr class="memdesc:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the system Stage when the connection should be made.  <a href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">More...</a><br /></td></tr>
<tr class="separator:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">isListSocket</a> () const</td></tr>
<tr class="memdesc:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Can this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> have more than one connectee?  <a href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">More...</a><br /></td></tr>
<tr class="separator:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">getNumConnectees</a> () const</td></tr>
<tr class="memdesc:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of slots to fill in order to satisfy this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">More...</a><br /></td></tr>
<tr class="separator:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">findAndConnect</a> (const std::string &amp;connectee)</td></tr>
<tr class="memdesc:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as <a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c" title="Find the connectee using a search with a partial path.">findAndConnect(const ComponentPath&amp;)</a>, but using a string argument.  <a href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">More...</a><br /></td></tr>
<tr class="separator:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">setConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="memdesc:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">More...</a><br /></td></tr>
<tr class="separator:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">setConnecteePath</a> (const std::string &amp;name, unsigned ix)</td></tr>
<tr class="memdesc:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">More...</a><br /></td></tr>
<tr class="separator:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">getConnecteePath</a> () const</td></tr>
<tr class="memdesc:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">More...</a><br /></td></tr>
<tr class="separator:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">getConnecteePath</a> (unsigned ix) const</td></tr>
<tr class="memdesc:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">More...</a><br /></td></tr>
<tr class="separator:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#afd80d0f355163910daea30d26a394430">appendConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="separator:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">clearConnecteePath</a> ()</td></tr>
<tr class="memdesc:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all connectee paths in the connectee path property.  <a href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">More...</a><br /></td></tr>
<tr class="separator:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">getOwner</a> () const</td></tr>
<tr class="memdesc:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get owner component of this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">More...</a><br /></td></tr>
<tr class="separator:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ae0aaecaff02932014d2c20d287a5f49c"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Socket.html">Socket</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Socket.html#ae0aaecaff02932014d2c20d287a5f49c">safeDownCast</a> (<a class="el" href="classOpenSim_1_1AbstractSocket.html">AbstractSocket</a> *base)</td></tr>
<tr class="memdesc:ae0aaecaff02932014d2c20d287a5f49c"><td class="mdescLeft">&#160;</td><td class="mdescRight">For use in python/java/MATLAB bindings.  <a href="classOpenSim_1_1Socket.html#ae0aaecaff02932014d2c20d287a5f49c">More...</a><br /></td></tr>
<tr class="separator:ae0aaecaff02932014d2c20d287a5f49c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a55336bf0a8b5e3b360eb49e58c0926c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55336bf0a8b5e3b360eb49e58c0926c2">&#9670;&nbsp;</a></span>~Socket()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::~<a class="el" href="classOpenSim_1_1Socket.html">Socket</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a904ec5f0a845926770538d90a17f4818"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a904ec5f0a845926770538d90a17f4818">&#9670;&nbsp;</a></span>Socket()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Socket.html">Socket</a> </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PropertyIndex &amp;&#160;</td>
          <td class="paramname"><em>connecteePathIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Stage &amp;&#160;</td>
          <td class="paramname"><em>connectAtStage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td>
          <td class="paramname"><em>owner</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> that can only connect to <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a> of type T with specified name and stage at which it should be connected. </p>
<p>Only <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> can ever construct this class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>name of the socket used to describe its dependency. </td></tr>
    <tr><td class="paramname">connecteePathIndex</td><td>Index of the property in the containing <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that holds this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a>'s connectee path(s). </td></tr>
    <tr><td class="paramname">connectAtStage</td><td>Stage at which <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> should be connected. </td></tr>
    <tr><td class="paramname">owner</td><td>The component that contains this input. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa7a4df9d9828850fe0d3cae7d7bb46dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa7a4df9d9828850fe0d3cae7d7bb46dc">&#9670;&nbsp;</a></span>clone()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Socket.html">Socket</a>&lt;T&gt;* <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::clone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a dynamically-allocated copy. </p>
<p>You must manage the memory for the returned pointer. This function exists to facilitate the use of SimTK::ClonePtr&lt;AbstractSocket&gt;. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#afa09afbf55e0e2feb0ebb83e446ab507">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="a5c3191db7766adfb42f7312c0d364ef4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5c3191db7766adfb42f7312c0d364ef4">&#9670;&nbsp;</a></span>connect()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td>
          <td class="paramname"><em>object</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> to the provided connectee object. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a48433b70cf9c41732ba587c9b5a1c25b">OpenSim::AbstractSocket</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1Socket.html#a4da865809554a425bbaa98f4a30a2dc0">OpenSim::Socket&lt; T &gt;::getConnecteeTypeName()</a>, and <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>.</p>

</div>
</div>
<a id="a9029eb41cd05fbbddae7259b464e008b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9029eb41cd05fbbddae7259b464e008b">&#9670;&nbsp;</a></span>disconnect()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::disconnect </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Clear references to connectees. </p>
<p>The connectee path property is not affected. Calling <a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367" title="Connect this Socket given its connectee path property">finalizeConnection()</a> will use the connectee path property to satisfy the socket. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#ac657088c315af6dc49b762d2acb81657">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="a78d4f73ee2cbba0e3052463d71017367"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78d4f73ee2cbba0e3052463d71017367">&#9670;&nbsp;</a></span>finalizeConnection()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class C &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; C &gt;::finalizeConnection </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td>
          <td class="paramname"><em>root</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> given its connectee path property <br  />
 </p>

<p>Reimplemented from <a class="el" href="classOpenSim_1_1AbstractSocket.html#a182a30262260a0503336a0d13d4b6c8d">OpenSim::AbstractSocket</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1ComponentPath.html#a85fde6c4e026fca2d6dafc22755698db">OpenSim::ComponentPath::getNumPathLevels()</a>, <a class="el" href="classOpenSim_1_1ComponentPath.html#af3b216b7291edc20f6ee0fb06fda9788">OpenSim::ComponentPath::getSubcomponentNameAtLevel()</a>, <a class="el" href="classOpenSim_1_1ComponentPath.html#a023ec59bf5dc4ccf302b1f2d05696f5f">OpenSim::ComponentPath::isAbsolute()</a>, and <a class="el" href="classOpenSim_1_1ComponentPath.html#a465df0b4170dd05426f0f69572ca4d99">OpenSim::ComponentPath::toString()</a>.</p>

</div>
</div>
<a id="accb8a43c9bc42c12d37d80836ece8de4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#accb8a43c9bc42c12d37d80836ece8de4">&#9670;&nbsp;</a></span>findAndConnect()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class C &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; C &gt;::findAndConnect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;&#160;</td>
          <td class="paramname"><em>connectee</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Find a component using a partial path or component name of the correct type anywhere in the model (using Component::findComponent()) and connect to that component. </p>
<p>Throws an exception If you provide only a component name and the model has multiple components with that nume. </p>

<p>Reimplemented from <a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c">OpenSim::AbstractSocket</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1ComponentPath.html#a465df0b4170dd05426f0f69572ca4d99">OpenSim::ComponentPath::toString()</a>.</p>

</div>
</div>
<a id="aa5eba84c6d4b19217bfe2db20f895b47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5eba84c6d4b19217bfe2db20f895b47">&#9670;&nbsp;</a></span>getConnectee()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class C &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">const C &amp; <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; C &gt;::getConnectee</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Temporary access to the connectee for testing purposes. </p>
<p>Real usage will be through the <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> (and <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>) interfaces. For example, <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> should short circuit to its <a class="el" href="classOpenSim_1_1Output.html">Output</a>'s getValue() once it is connected. Return a const reference to the object connected to this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> </p>

</div>
</div>
<a id="a25c9aaf45468ad895c5b1bc8bc7c9246"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25c9aaf45468ad895c5b1bc8bc7c9246">&#9670;&nbsp;</a></span>getConnecteeAsObject()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T&amp; <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::getConnecteeAsObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Generic access to the connectee. </p>
<p>Not all sockets support this method (e.g., the connectee for an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> is not an <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>). </p>

<p>Reimplemented from <a class="el" href="classOpenSim_1_1AbstractSocket.html#ab7f51d3c1a841f4e3f00b38fee88c75e">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="a4da865809554a425bbaa98f4a30a2dc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4da865809554a425bbaa98f4a30a2dc0">&#9670;&nbsp;</a></span>getConnecteeTypeName()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::getConnecteeTypeName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Derived classes must satisfy this Interface. </p>
<p>get the type of object this socket connects to </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a8bd9bdc7613c88f6f92e9c53d3e6bd99">OpenSim::AbstractSocket</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Socket.html#a5c3191db7766adfb42f7312c0d364ef4">OpenSim::Socket&lt; T &gt;::connect()</a>.</p>

</div>
</div>
<a id="a85d80ce024bb2ba53cc52019f91ca7bc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85d80ce024bb2ba53cc52019f91ca7bc">&#9670;&nbsp;</a></span>isConnected()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::isConnected </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Is the <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> connected to object of type T? </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a20d1a94495d9e45850004cab9b91b1f7">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="ae0aaecaff02932014d2c20d287a5f49c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae0aaecaff02932014d2c20d287a5f49c">&#9670;&nbsp;</a></span>safeDownCast()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Socket.html">Socket</a>&lt;T&gt;* <a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::safeDownCast </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1AbstractSocket.html">AbstractSocket</a>&lt; T &gt; *&#160;</td>
          <td class="paramname"><em>base</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>For use in python/java/MATLAB bindings. </p>

</div>
</div>
<a id="a78e253243a1eab086aba8591ec1f9bb6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78e253243a1eab086aba8591ec1f9bb6">&#9670;&nbsp;</a></span>SimTK_DOWNCAST()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Socket.html">OpenSim::Socket</a>&lt; T &gt;::SimTK_DOWNCAST </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Socket.html">Socket</a>&lt; T &gt;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1AbstractSocket.html">AbstractSocket</a>&lt; T &gt;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>OpenSim/Common/ComponentSocket.h</li>
<li>OpenSim/Common/Component.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Socket.html">Socket</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:50 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
